%ext bm1
%version 1.1

#Skip Apogee Fanfare demo. Note that it takes affect on any demo replay of it!
#%patch $3C7E $90 $90 $90 $90 $90

#To activate cheats, JIM+Space should be sufficient:
#The need for the COD stuff should be gone.
%patch $6406 $90 $90

#TEST: Remove the "Practice a level" choice from the menu?
%patch $27A43 $00
%patch $27A47 $00 $00 $00 $00
#%patch $20AF0 "  Practice which level (1-11): " $00

#No lower menu text
%patch $1DF01 $24F4W
%patch $1DF07 $24F4W
%patch $1DF11 $24F4W
%patch $1DF16 $24F4W

#Change Help Menu Song
%patch $4BF5 $68 $02W

#######Cosmos/Calamari############

#Make Cosmos move faster
%patch $232BA $06
%patch $232DA $06
%patch $232FA $06
%patch $2331A $06

#######End Cosmos/Calamari############

#######Big Gun Rat/Calamari w/ Gun############

#Big Gun/rat enemy appears over foreground tiles.
#Side effect: Also appears over scorebox.
#This is a bit more tricky to patch. Also removing little code duplication
#and shifting some other code.
%patch $13674 $C7 $47 $02 $02 $00
              $C7 $47 $04 $01 $00
              $C7 $47 $22 $03 $00 #This is the new addition
              $90 $90 $90

#Big Gun/rat spawned shots locations:
#A few (relative) values to play with.
%patch $137B0 $00 $03
%patch $137C5 $A0 $01

#Change the enemy shot (frame 62) explosion frames, from 57-58 to 115-116.
#WARNING: It MIGHT affect a different thing with the same explosion as well.
#%patch $237F0 $0073W  $0073W
#%patch $23810 $0074W  $0074W

#######End Big Gun Rat/Calamari w/ Gun############

#######Purple Critter/Skab############

#Purple critters take more hits
%patch $12076 $0A $00 #On Hard
%patch $12081 $05 $00 #On Easy and Normal

#purple critters jump/lunge further
#%patch $1218F $E0 $FF
#%patch $121E0 $20 $00
%patch $1218F $D0 $FF #Left
%patch $121E0 $30 $00 #Right

#######End Purple Critter/Skab############

#######Fire Imp/Jumping Calamari############

#We want the fire imp to get injured by grenades. How?
#Well, lets change its sprite type to be the same as the cyan snake.
#NOTE: Gibs stay the same as before (red splat).
%patch $12666 $0019W

#Fire imp uses just 3 pairs of frames for the walking animations
#(and not the two jumping frames). As a result, segment 0x2311 is free'd.
%patch $2310C $230B0000RL

#Fire imp walks slower
%patch $230BC $80
%patch $230DC $80
%patch $230FC $80
#%patch $2311C $80 #Unused frame for now

#TEST: Fire imp jumps slower?
%patch $127D3 $04 #Shift left some value by 4, instead of 5

#Fire imp doesn't turn into fire:
#Usually, this is determined according to some randomized value with a
#conditional jump. This time, we make sure that the jump isn't conditional.
#%patch $12759 $EB

#For the fire imp, don't call a "sprite behavior" function which,
#given a specific condition being met, changes to fire frames.
#This also frees up small code space!! (Code start location: $126E2)
#QUESTION: Should relative addressing be used here or not?
#%patch $230C0 $00000000RL
%patch $230C0 $00000000L

#But then, there's a little glitch regarding the fire imp:
#If it jumps to the left and hits both a wall and a floor (more or less),
#you MIGHT see a fire frame for a while.
#The mention of a fire frame segment seems to be related.
#Lets try swapping with a different (jumping) segment.
%patch $1275C $2319RW

#Now though, it may not jump sufficiently often.
#Lets try reducing some randomness value.
#%patch $12757 $0080W

#######End Fire Imp/Jumping Calamari############

#######Cyan Snake/Docthulu############

#Cyan snake shots test
#%patch $11026 $02 $00 #(instead of $03 $00 and same as block tile 386)
#%patch $11023 $C7 $47 $06 $01 $00

%patch $10FAC $0028W #Change sprite type: Same as fire imp; Instead of $0019W.
                     #Doesn't respond to grenades; Still responds to shots.

#Make shot move at some fast CONSTANT rate (not depending on snake speed).
#Needs a little recoding, not so mcuh though.
%patch $10FFF $83 $7C $0E $00
              $7F $05
              $B8 $FFD0W #Shot speed if moving left
              $EB $05
              $B8 $0030W #Shot speed if moving right
              $90 $90
#%patch $11008 $00034W #Make it move horizontally faster; Use instead of $0028W.
#                     #NOTE: Currently uneven among right/left speeds and may
#                     #depend on the current snake speed.
###This is a little more tricky, moving little code around to free space...###
%patch $11016 $C7 $47 $18 $0000W #Don't start with any vertical move (Default up)
#%patch $11016 $C7 $47 $18 $FFECW
              $C7 $47 $02 $0003W
              $C7 $47 $40 $0001W #Now one can hit the Snake's shot
#             $90 $90 $90
              $C7 $47 $44 $7F7FW #Set a practically infinite strength...
              $68 $22A3RW
              $6A $00
              $90
#Act like blue shots (lasers)
%patch $22A40 $08141AC1RL #Behavior
%patch $22A48 $12F20936RL #Tile collision
%patch $22A60 $08141AC1RL #Behavior
%patch $22A68 $12F20936RL #Tile collision

#######End Cyan Snake/Docthulu############

###UPDATE: Please ignore the following cheat-related thing.
###Apparently, the code has somehow been modified *within* the EXE!
###I've placed another copy of the EXE (for now in original compressed form).
###Seems to work with the patcher so far, along with the "91827" code...
#For some weird reason, at least for this MOD in the current state,
#the imported stuff seem to corrupt the "91827" code for cheats
#(probably an importing bug).
#Re-patching it seems to fix that.
#%patch $296FB "91827"

%end

%patch $2895 $24F4W
%patch $8a80 $24F4W	
%patch $14c69 $24F4W
%patch $1B9A9 $24F4W
